{
 	File:		MacLocales.p
 
 	Contains:	Types & prototypes for locale functions
 
 	Version:	Technology:	Veronica
 				Release:	Veronica Seed, Use with 3.2 Universal Interfaces
 
 	Copyright:	 1998-1999 by Apple Computer, Inc., all rights reserved.
 
 	Bugs?:		For bug reports, consult the following page on
 				the World Wide Web:
 
 					http://developer.apple.com/bugreporter/
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT MacLocales;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __MACLOCALES__}
{$SETC __MACLOCALES__ := 1}

{$I+}
{$SETC MacLocalesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __MACTYPES__}
{$I MacTypes.p}
{$ENDC}


{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{
   -------------------------------------------------------------------------------------------------
   ERROR/STATUS CODES
   -------------------------------------------------------------------------------------------------
}


CONST
	kLocalesBufferTooSmallErr	= -30001;
	kLocalesDefaultDisplayStatus = -30029;						{  Requested display locale unavailable, used default }

{
   -------------------------------------------------------------------------------------------------
   TYPES & CONSTANTS
   -------------------------------------------------------------------------------------------------
}


TYPE
	LocaleRef = ^LONGINT;
	LocalePartMask						= UInt32;

CONST
																{  bit set requests the following: }
	kLocaleLanguageMask			= $00000001;					{  ISO 639-1 or -2 language code (2 or 3 letters) }
	kLocaleLanguageVariantMask	= $00000002;					{  custom string for language variant }
	kLocaleScriptMask			= $00000004;					{  ISO 15924 script code (2 letters) }
	kLocaleScriptVariantMask	= $00000008;					{  custom string for script variant }
	kLocaleRegionMask			= $00000010;					{  ISO 3166 country/region code (2 letters) }
	kLocaleRegionVariantMask	= $00000020;					{  custom string for region variant }
	kLocaleAllPartsMask			= $0000003F;					{  all of the above }


TYPE
	LocaleOperationClass				= FourCharCode;

CONST
	kUnicodeCollationClass		= 'ucol';
	kUnicodeTextBreakClass		= 'ubrk';


TYPE
	LocaleOperationVariant				= FourCharCode;
	LocaleAndVariantPtr = ^LocaleAndVariant;
	LocaleAndVariant = RECORD
		locale:					LocaleRef;
		opVariant:				LocaleOperationVariant;
	END;

	LocaleNameMask						= UInt32;

CONST
																{  bit set requests the following: }
	kLocaleNameMask				= $00000001;					{  name of locale }
	kLocaleOperationVariantNameMask = $00000002;				{  name of LocaleOperationVariant }
	kLocaleAndVariantNameMask	= $00000003;					{  all of the above }

{
   -------------------------------------------------------------------------------------------------
   FUNCTION PROTOTYPES
   -------------------------------------------------------------------------------------------------
}

{  Convert to or from LocaleRefs  }

FUNCTION LocaleRefFromLangOrRegionCode(lang: LangCode; region: RegionCode; VAR locale: LocaleRef): OSStatus; C;
FUNCTION LocaleRefFromLocaleString(localeString: ConstCStringPtr; VAR locale: LocaleRef): OSStatus; C;
FUNCTION LocaleRefGetPartString(locale: LocaleRef; partMask: LocalePartMask; maxStringLen: ByteCount; partString: CStringPtr): OSStatus; C;
{  Enumerate locales for a LocaleOperationClass  }

FUNCTION LocaleOperationCountLocales(opClass: LocaleOperationClass; VAR localeCount: ItemCount): OSStatus; C;
FUNCTION LocaleOperationGetLocales(opClass: LocaleOperationClass; maxLocaleCount: ItemCount; VAR actualLocaleCount: ItemCount; VAR localeVariantList: LocaleAndVariant): OSStatus; C;
{  Get names for a locale }

FUNCTION LocaleGetName(locale: LocaleRef; opVariant: LocaleOperationVariant; nameMask: LocaleNameMask; displayLocale: LocaleRef; maxNameLen: UniCharCount; VAR actualNameLen: UniCharCount; VAR displayName: UniChar): OSStatus; C;
FUNCTION LocaleCountNames(locale: LocaleRef; opVariant: LocaleOperationVariant; nameMask: LocaleNameMask; VAR nameCount: ItemCount): OSStatus; C;
FUNCTION LocaleGetIndName(locale: LocaleRef; opVariant: LocaleOperationVariant; nameMask: LocaleNameMask; nameIndex: ItemCount; maxNameLen: UniCharCount; VAR actualNameLen: UniCharCount; VAR displayName: UniChar; VAR displayLocale: LocaleRef): OSStatus; C;
{  Get names for a LocaleOperationClass }

FUNCTION LocaleOperationGetName(opClass: LocaleOperationClass; displayLocale: LocaleRef; maxNameLen: UniCharCount; VAR actualNameLen: UniCharCount; VAR displayName: UniChar): OSStatus; C;
FUNCTION LocaleOperationCountNames(opClass: LocaleOperationClass; VAR nameCount: ItemCount): OSStatus; C;
FUNCTION LocaleOperationGetIndName(opClass: LocaleOperationClass; nameIndex: ItemCount; maxNameLen: UniCharCount; VAR actualNameLen: UniCharCount; VAR displayName: UniChar; VAR displayLocale: LocaleRef): OSStatus; C;
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := MacLocalesIncludes}

{$ENDC} {__MACLOCALES__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
